#include <stdio.h>
#include <stdlib.h>
#define DIM 30
int ptoSospechoso(int matriz[DIM][DIM][DIM], int ptoX, int ptoY, int ptoZ);
int cuentaLineas(int m[DIM][DIM][DIM], int plano);
int esLineaSosp(int m[DIM][DIM][DIM], int za, int xa);
void localizarMaximo(int vector[], int *maxlinea, int *maxvalor);

//Funciones auxiliares para probar el funcionamiento del programa
void inicializar(int m[DIM][DIM][DIM]);
void aniadirLineas(int m[DIM][DIM][DIM]);


int main(void){
  int matriz[DIM][DIM][DIM]; // imagen original
  int m2 [DIM][DIM][DIM]; //matriz en la que los puntos sospechosos valen 1, el resto 0
  int lineasXPlano[DIM];
  int x,y,z;
  int i;
  int maxLineas, maxValor;

  //Se inicializa la matriz. NO SE PIDE EN EL ENUNCIADO 
  inicializar(matriz);
  
// se obtiene la matriz m2 en la que los puntos sospechosos valen 1, el resto 0
// los puntos de los bordes no se analizarn
  
  for(x=1;x<DIM-1;x++){
    for(y=1;y<DIM-1;y++){
      for(z=1;z<DIM-1;z++){
         m2[x][y][z]=ptoSospechoso(matriz,x,y,z); 
         if (m2[x][y][z]==1)   
           printf ("%d %d %d\n", x, y, z);
      }
    }
  }
  
  //Aadimos lineas para comprobar funcionamiento
  aniadirLineas(m2);
  //Se cuentan las lineas por plano y se muestran por pantalla. 
  for(z=1;z<DIM-1;z++){
    lineasXPlano[z]=cuentaLineas(m2,z);
    printf ("Las lineas en el plano %d son %d\n", z, lineasXPlano[z]);
  }
  
  localizarMaximo(lineasXPlano, &maxLineas, &maxValor);
  printf("\n");
  printf("El palno con mas lineas sospechosas es el\n");
  printf(" Plano %i con %i lineas sospechosas\n",maxLineas, maxValor);
 
  system("PAUSE");
  return;
}

int ptoSospechoso(int matriz[DIM][DIM][DIM], int ptoX, int ptoY, int ptoZ){
// version simplificada, no se comprueban los bordes
// se puede poner tambin la de javi que es la version complicada
  int sospechoso;
  int adyacentes=0;
  int i,j,k;
  for(i=ptoX-1;i<=ptoX+1;i++){
    for(j=ptoY-1;j<=ptoY+1;j++){
      for(k=ptoZ-1;k<=ptoZ+1;k++){
          if (!( ((i==ptoX) && (j==ptoY) && (k==ptoZ)))){
          //se excluye el punto sobre el que se evalua
          // son sospechosos los puntos con valores entre 20 y 40
              if ( (matriz[i][j][k]>=20) && (matriz[i][j][k]<=40) ){
                 adyacentes++;                 
              }
          }
       }
    }
   }
   if (adyacentes==26){
       sospechoso=1;
       
   }
   else
       sospechoso=0;
   return sospechoso;
}


int cuentaLineas(int m[DIM][DIM][DIM], int plano){
// analiza todas las lineas horizontales de un plano
// contando las que son lineas sospechosas
  int nbLineas = 0;
  int linea;
  for (linea=1; linea<DIM-1; linea++){
    if (esLineaSosp(m, plano, linea)){
      nbLineas++;
    }
  }
  return nbLineas;
}

int esLineaSosp(int m[DIM][DIM][DIM], int za, int xa){
// funcin que devuelve 1 si la linea es sospechosa, 0 en caso contrario
  int esSosp=0; //
  int y=1; // representa la y de la linea a analizar
  //comenzando desde el primer punto de la linea, se va viendo si hay
  //tres sospechosos consecutivos
  //se recorre hasta el final de la linea o hasta que ya sea sospechosa
  while ((y<(DIM-3))&&(esSosp==0)){
    if ((((m[xa][y][za])==1) && (m[xa][y+1][za]==1))&& ( m[xa][y+2][za]==1)){
         esSosp=1;
    }
    y ++;
  }  //while
  return esSosp;
}


void inicializar(int m[DIM][DIM][DIM]){
  int x, y, z;
  for(x=0;x<DIM;x++){
    for(y=0;y<DIM;y++){
      for(z=0;z<DIM;z++){
        m [x][y][z] = 0; // fuerzo a que no haya ningun punto sospechoso
      }
    }
   }
   
   //Para Probar introduzco un punto sospechoso: (4,4,4)
   m [4][4][4]=0;

   m [3][3][5]=25;
   m [4][3][5]=25;
   m [5][3][5]=25;
   m [5][4][5]=25;
   m [5][5][5]=25;   
   m [4][5][5]=25;      
   m [3][5][5]=25;         
   m [3][4][5]=25;      
   m [4][4][5]=25;         
   
   m [3][3][4]=25;
   m [4][3][4]=25;
   m [5][3][4]=25;
   m [5][4][4]=25;
   m [5][5][4]=25;   
   m [4][5][4]=25;      
   m [3][5][4]=25;         
   m [3][4][4]=25;      
   //m [4][4][4]=25;         

   m [3][3][3]=25;
   m [4][3][3]=25;
   m [5][3][3]=25;
   m [5][4][3]=25;
   m [5][5][3]=25;   
   m [4][5][3]=25;      
   m [3][5][3]=25;         
   m [3][4][3]=25;      
   m [4][4][3]=25;         
   //-------------
   
   m [3][4][5]=25;
   m [4][4][5]=25;
   m [5][4][5]=25;
   m [5][5][5]=25;
   m [5][6][5]=25;   
   m [4][6][5]=25;      
   m [3][6][5]=25;         
   m [3][5][5]=25;      
   m [4][5][5]=25;         
   
   m [3][4][4]=25;
   m [4][4][4]=25;
   m [5][4][4]=25;
   m [5][5][4]=25;
   m [5][6][4]=25;   
   m [4][6][4]=25;      
   m [3][6][4]=25;         
   m [3][6][4]=25;      
   //m [4][4][4]=25;         

   m [3][4][3]=25;
   m [4][4][3]=25;
   m [5][4][3]=25;
   m [5][5][3]=25;
   m [5][6][3]=25;   
   m [4][6][3]=25;      
   m [3][6][3]=25;         
   m [3][5][3]=25;      
   m [4][5][3]=25;   
   
   //----
   m [3][5][5]=25;
   m [4][5][5]=25;
   m [5][5][5]=25;
   m [5][6][5]=25;
   m [5][7][5]=25;   
   m [4][7][5]=25;      
   m [3][7][5]=25;         
   m [3][6][5]=25;      
   m [4][6][5]=25;         
   
   m [3][5][4]=25;
   m [4][5][4]=25;
   m [5][5][4]=25;
   m [5][6][4]=25;
   m [5][7][4]=25;   
   m [4][7][4]=25;      
   m [3][7][4]=25;         
   m [3][6][4]=25;      
   //m [4][4][4]=25;         

   m [3][5][3]=25;
   m [4][5][3]=25;
   m [5][5][3]=25;
   m [5][6][3]=25;
   m [5][7][3]=25;   
   m [4][7][3]=25;      
   m [3][7][3]=25;         
   m [3][6][3]=25;      
   m [4][6][3]=25;    
   
   
   return;
}

void aniadirLineas(int m[DIM][DIM][DIM]){
       
  // para probar, grabo dos lineas sospechosas en el plano 4 y una en el 5
  // las lineas horizontales comparten la misma z y la misma x
  // plano z=4
  // linea x = 10
   m [10][11][4]=1;
   m [10][12][4]=1;
   m [10][13][4]=1;
   // linea x = 20
   m [20][11][4]=1;
   m [20][12][4]=1;
   m [20][13][4]=1;
   // plano z= 5
   // linea x = 10
   m [10][11][5]=1;
   m [10][12][5]=1;
   m [10][13][5]=1;
   return;   
}


void localizarMaximo(int vector[], int *maxLineas, int *maxValor){
  //se localiza el mximo de un vector y la posicin que ocupa:

  int max, i, indice;
  indice=0;
  max=vector[indice];

  
  for (i=1; i<DIM; i++)
     if (vector[i]>max){
        indice=i;
        max=vector[indice];
     }
       
  *maxLineas=indice;
  *maxValor=max;     
  return;
}
